org.springframework.context.event

## Annotation Type EventListener

-     @Target(value={METHOD,ANNOTATION_TYPE})
       @Retention(value=RUNTIME)
       @Documented
      public @interface EventListener

  Annotation that marks a method as a listener for application events.

  If an annotated method supports a single event type, the method may declare a single parameter that reflects the event type to listen to. If an annotated method supports multiple event types, this annotation may refer to one or more supported event types using the `classes` attribute. See the `classes()` javadoc for further details.

  Events can be `ApplicationEvent` instances as well as arbitrary objects.

  Processing of `@EventListener` annotations is performed via the internal `EventListenerMethodProcessor` bean which gets registered automatically when using Java config or manually via the `<context:annotation-config/>` or `<context:component-scan/>` element when using XML config.

  Annotated methods may have a non-`void` return type. When they do, the result of the method invocation is sent as a new event. If the return type is either an array or a collection, each element is sent as a new individual event.

  This annotation may be used as a meta-annotation to create custom composed annotations.

  ### Exception Handling

  While it is possible for an event listener to declare that it throws arbitrary exception types, any checked exceptions thrown from an event listener will be wrapped in an `UndeclaredThrowableException` since the event publisher can only handle runtime exceptions.

  ### Asynchronous Listeners

  If you want a particular listener to process events asynchronously, you can use Spring's `@Async` support, but be aware of the following limitations when using asynchronous events.

  - If an asynchronous event listener throws an exception, it is not propagated to the caller. See `AsyncUncaughtExceptionHandler` for more details.
  - Asynchronous event listener methods cannot publish a subsequent event by returning a value. If you need to publish another event as the result of the processing, inject an `ApplicationEventPublisher` to publish the event manually.

  ### Ordering Listeners

  It is also possible to define the order in which listeners for a certain event are to be invoked. To do so, add Spring's common `@Order` annotation alongside this event listener annotation.

  Since:
    4.2
  Author:
    Stephane Nicoll, Sam Brannen
  See Also:
    `EventListenerMethodProcessor`, `TransactionalEventListener`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `Class<?>[]` | `classes` The event classes that this listener handles.
    `String` | `condition` Spring Expression Language (SpEL) expression used for making the event handling conditional.
    `String` | `id` An optional identifier for the listener, defaulting to the fully-qualified signature of the declaring method (e.g.
    `Class<?>[]` | `value` Alias for `classes()`.

- - ### Element Detail

    - #### value

          @AliasFor(value="classes")
          public abstract Class<?>[] value

      Alias for `classes()`.
      Default:
        {}

  - - #### classes

          @AliasFor(value="value")
          public abstract Class<?>[] classes

      The event classes that this listener handles.

      If this attribute is specified with a single value, the annotated method may optionally accept a single parameter. However, if this attribute is specified with multiple values, the annotated method must not declare any parameters.

      Default:
        {}

  - - #### condition

          public abstract String condition

      Spring Expression Language (SpEL) expression used for making the event handling conditional.

      The event will be handled if the expression evaluates to boolean `true` or one of the following strings: `"true"`, `"on"`, `"yes"`, or `"1"`.

      The default expression is `""`, meaning the event is always handled.

      The SpEL expression will be evaluated against a dedicated context that provides the following metadata:

      - `#root.event` or `event` for references to the `ApplicationEvent`
      - `#root.args` or `args` for references to the method arguments array
      - Method arguments can be accessed by index. For example, the first argument can be accessed via `#root.args[0]`, `args[0]`, `#a0`, or `#p0`.
      - Method arguments can be accessed by name (with a preceding hash tag) if parameter names are available in the compiled byte code.
      Default:
        ""

  - - #### id

          public abstract String id

      An optional identifier for the listener, defaulting to the fully-qualified signature of the declaring method (e.g. "mypackage.MyClass.myMethod()").
      Since:
        5.3.5
      See Also:
        `SmartApplicationListener.getListenerId()`, `ApplicationEventMulticaster.removeApplicationListeners(Predicate)`
      Default:
        ""